#!/bin/bash
#$1 is /opt/lcg/etc/tankspark/lcgtankspark.conf
#proviamo a rendere automatico lo startup sotto init.d con rsyncd
in_file=$1

CONF=`sed -n '/rsyncconf=/p' $in_file | sed 's/rsyncconf=//'`
PORT=`sed -n '/rsyncport=/p' $in_file | sed 's/rsyncport=//'`
LCG_LOCATION=${LCG_LOCATION:=/opt/lcg}

#creates the repository area for each VO
${LCG_LOCATION}/etc/tankspark/create_rsyncdir.sh $1
#writes the configuration file+ /etc/rsyncd.secrets and /etc/rsyncs.greetings: basic security applied
${LCG_LOCATION}/etc/tankspark/fill_Rsynconf.sh $1
echo "#!/bin/bash" > "/etc/init.d/rsyncd"
echo "# description: Starts, stops , query rsync daemon" >> "/etc/init.d/rsyncd"
echo '# chkconfig: 345 95 15' >> "/etc/init.d/rsyncd"
echo '#'>> "/etc/init.d/rsyncd"
echo '# Version:        @(#) /etc/init.d/rsyncd   1.2' >> "/etc/init.d/rsyncd"
echo "" >> "/etc/init.d/rsyncd"
echo "# Source function library" >> "/etc/init.d/rsyncd"
echo ". /etc/rc.d/init.d/functions" >> "/etc/init.d/rsyncd"
echo "" >> "/etc/init.d/rsyncd"
echo "start()" >> "/etc/init.d/rsyncd"
echo "{" >> "/etc/init.d/rsyncd"
echo "rsync --daemon --config=${CONF} --port=${PORT} ">> "/etc/init.d/rsyncd"
echo '[ "$?" -eq 0 ] && success $"rsync startup" || failure $"rsync startup"'>> "/etc/init.d/rsyncd" 
echo "echo \`pidofproc rsync\` > /var/run/rsync.pid" >> "/etc/init.d/rsyncd"
echo "}">> "/etc/init.d/rsyncd"
echo "" >> "/etc/init.d/rsyncd"
echo "stop()" >> "/etc/init.d/rsyncd"
echo "{" >> "/etc/init.d/rsyncd"
echo " killproc rsync" >> "/etc/init.d/rsyncd"
echo "}">> "/etc/init.d/rsyncd" 
echo "">> "/etc/init.d/rsyncd"
echo "status()" >> "/etc/init.d/rsyncd"
echo "{" >> "/etc/init.d/rsyncd"
echo "local pid=" >> "/etc/init.d/rsyncd" 
echo "pid=\`pidofproc rsync\`" >> "/etc/init.d/rsyncd"
echo 'if [ -n "$pid" ]; then' >> "/etc/init.d/rsyncd"
echo ' echo "rsync running in pid: ${pid}"' >> "/etc/init.d/rsyncd"
echo 'elif [ -f /var/run/rsync.pid ]; then'>> "/etc/init.d/rsyncd"
echo '    echo "rsync not running but stale pid file present."'>> "/etc/init.d/rsyncd"
echo "    exit 1">> "/etc/init.d/rsyncd"
echo "  else">> "/etc/init.d/rsyncd"
echo "    echo \"rsync not running\"">> "/etc/init.d/rsyncd"
echo "  fi">> "/etc/init.d/rsyncd"
echo "}">> "/etc/init.d/rsyncd"
echo "" >> "/etc/init.d/rsyncd"
echo "case \$1 in" >> "/etc/init.d/rsyncd"
echo "    start)" >> "/etc/init.d/rsyncd"
echo "	echo -n \"Starting rsync service...\"">> "/etc/init.d/rsyncd"
echo "">> "/etc/init.d/rsyncd"
echo "	start">> "/etc/init.d/rsyncd"
echo "	RETVAL=\$?">> "/etc/init.d/rsyncd"
echo "    ;;">> "/etc/init.d/rsyncd"
echo "    stop)">> "/etc/init.d/rsyncd"
echo "	echo -n \"Stopping rsync service...\"">> "/etc/init.d/rsyncd"
echo "">> "/etc/init.d/rsyncd"
echo "	stop">> "/etc/init.d/rsyncd"
echo "	RETVAL=\$?">> "/etc/init.d/rsyncd"
echo "    ;;">> "/etc/init.d/rsyncd"
echo "    restart)">> "/etc/init.d/rsyncd"
echo "	echo -n \"Stopping rsync service...\"">> "/etc/init.d/rsyncd"
echo "	stop">> "/etc/init.d/rsyncd"
echo "	echo -n \"Starting rsync service...\"">> "/etc/init.d/rsyncd"
echo "	start">> "/etc/init.d/rsyncd"
echo "	RETVAL=\$?">> "/etc/init.d/rsyncd"
echo "    ;;">> "/etc/init.d/rsyncd"
echo "    status)">> "/etc/init.d/rsyncd"
echo "	status">> "/etc/init.d/rsyncd"
echo "	RETVAL=\$?">> "/etc/init.d/rsyncd"
echo "    ;;">> "/etc/init.d/rsyncd"
echo "    *)">> "/etc/init.d/rsyncd"
echo "	echo \"Usage: \$0 {start|stop|restart|status|proxy}\"">> "/etc/init.d/rsyncd"
echo "	RETVAL=1">> "/etc/init.d/rsyncd"
echo "    ;;">> "/etc/init.d/rsyncd"
echo "esac">> "/etc/init.d/rsyncd"
echo "exit \$RETVAL">> "/etc/init.d/rsyncd"


chmod a+x /etc/init.d/rsyncd
/sbin/chkconfig --add rsyncd
/sbin/chkconfig rsyncd on

#start the service

/etc/init.d/rsyncd start
